/* */
  if Pop() <> 0 then exit 9901

  if stream(TXTFILE,'c','open read') <> 'READY:'
  then
    do
      say GetMsg(10,TXTFILE)
      exit 9
    end

  prev_grp = ''
  LVL_CURR = 0
  LVL_PREV = 0
  LVL_2_SEQ = 0
  LVL_3_SEQ = 0
  INPUT_SEQ = 0

  x = KeyWords()

  PushList = PushList||,
             'LVL_2_SEQ' 'LVL_3_SEQ' 'LVL_PREV' 'LVL_CURR' 'INPUT_SEQ'

  say GetMsg(8,'01')

  x = Push('APPMSG' 'INIFILE' 'TXTFILE')

  rc = SPMAPP02('start')

  if rc <> 0 then exit rc

  seq = 0
  finish = 'n'

  do while finish = 'n'
    if lines(TXTFILE) <> 0
      then inline = strip(linein(TXTFILE))
      else inline = END

    seq = seq + 1

    fld = substr(inline,1,1)
    if fld = '*' then iterate

    fld = translate(substr(inline,1,3))
    if fld = END
    then
        finish = 'y'
    else
      do
        pos = verify(inline,'=','M')

        if pos = 0
        then
          do
            say GetMsg(11,seq,inline)
            iterate
          end

        fld = translate(substr(inline,1,pos-1))
        fval = substr(inline,pos+1)
        if substr(fval,1,1) = ' ' then fval = ''

        if substr(fval,1,1) = '"'
        then
          do
            last = substr(fval,length(fval))

            do while last <> '"'
              fval1 = strip(linein(TXTFILE))
              last = substr(fval1,length(fval1))
             fval = fval||' '||fval1
            end

            fval = translate(fval, '^', '''')
            fval = strip(fval,'B','"')
          end
      end

    if datatype(fld,'N')
    then
      do
        say GetMsg(12,seq,inline)
        iterate
      end

    pos = wordpos(fld, KwdList)

    if pos = 0
    then
      do
        say GetMsg(12,seq,inline)
        iterate
      end

    LVL_CURR = word(KwdList, pos+1)

    if LVL_PREV > LVL_1
    then
      if LVL_CURR <> LVL_PREV
      then
        if (LVL_CURR = LVL_2) | (LVL_CURR = LVL_3)
        then
          do
            INPUT_SEQ = seq

            x = Push('APPMSG' PushList)

            rc = SPMAPP02()

            if rc <> 0 then leave

            x = Initialize(LVL_3)

            LVL_3_SEQ = LVL_3_SEQ + 1

            if LVL_CURR = LVL_2
            then
              do
                x = Initialize(LVL_2)
                LVL_2_SEQ = LVL_2_SEQ + 1
                LVL_3_SEQ = 0
              end
          end

    LVL_PREV = LVL_CURR

    interpret fld "= fval"
  end

  x = Push( 'APPMSG' 'TXTFILE' 'INIFILE' )

  if rc = 0
  then
    fc = SPMAPP02('finish')
  else
    fc = SPMAPP02('cleanup')

  rc = max(rc,fc)

  x = stream(TXTFILE,'c','close')

  say GetMsg(9,'01')
  return rc

 /* * * * * */

KeyWords:
  x = Retrieve('DCL','KWDS',"item")

  cKwd = s2d(substr(item,1,2))
  desc = substr(item,3,cKwd*4)
  names = substr(item,3+length(desc))

  j = 4 * cKwd
  KwdList = ''

  do i = 1 to j by 4
    off = s2d(substr(desc,i,2))
    val = s2d(substr(desc,i+2,2))

    KwdList = KwdList||szstr(names,off+2)||' '||val||' '
  end

  KwdList = translate(KwdList)

  j = (cKwd * 2) - 1

  END = word(KwdList, j)

  j = j - 2
  PushList = ''

  do i = 1 by 2 to j
    PushList = PushList||subword(KwdList,i,1)||' '
  end

  x = Retrieve('DCL','LVLS',"item")

  j = s2d(substr(item,1,2))
  desc = substr(item,3,j*4)
  names = substr(item,3+length(desc))

  j = 4 * j

  do i = 1 to j by 4
    var = szstr(names,s2d(substr(desc,i,2))+2)
    val = s2d(substr(desc,i+2,2))

    interpret var '=' val
  end

  drop item desc names off
  return 0

Retrieve:
  parse arg _app,_key,_item

  _data = SysIni(INIFILE,_app,_key)

  if _data = 'ERROR:'
  then
    do
      say GetMsg(14,_app,_key)
      exit 14
    end
  else
    do
      interpret _item '= _data'
      return 0
    end

 /* * * * * */

Initialize:
  arg lvl

  j = (cKwd * 2) - 3

  do i = 1 by 2 to j
    var = subword(KwdList,i,1)
    val = subword(KwdList,i+1,1)

    if val >= lvl then interpret var '= ""'
  end

  return 0
